import {
  csv
} from 'd3';

var map = L.map('map').setView([52.372797, 4.9042115], 13);
var current;
var connection = "previous";  //previous/random
var showLines = false;
var maxGrowth = 120;
var spread = 10;
var circleColor = "orange";
var circleColors = {
  reseller: "red",
  event: "green",
  origin: "black",
  default: circleColor,  
}
var kombuchaColors = ["orange","#f4d142", "#ddb616", "#bfb60b"];  //["white"]//
var lineColor = "lightyellow";
var hot = "http://{s}.tile.openstreetmap.fr/hot/{z}/{x}/{y}.png";
var stamen = "https://stamen-tiles-{s}.a.ssl.fastly.net/watercolor/{z}/{x}/{y}.png";
var grayScale = "https://korona.geog.uni-heidelberg.de/tiles/roadsg/x={x}&y={y}&z={z}";
var water = "https://{s}.tile.openstreetmap.se/hydda/base/{z}/{x}/{y}.png";
var terrain = "http://stamen-tiles-{s}.a.ssl.fastly.net/terrain/{z}/{x}/{y}.{ext}";
var dark = "http://{s}.basemaps.cartocdn.com/dark_nolabels/{z}/{x}/{y}.png";

/////////////
var style = dark;
/////////////

L.tileLayer(style, {
    attribution: 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a> &mdash; Map data &copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>',
	subdomains: 'abcd',
	minZoom: 1,
	maxZoom: 16,
	ext: 'png'
}).addTo(map);

let circles = [];
let childCircles = [];
let lines = [];
console.log("data successfully loaded from external codepen?", dataPoints != undefined);
console.table(dataPoints);
dataPoints.forEach(generateCircle);


// d3.json('datapoints.js')
//   .then(dataPoints => {
//   	console.log("Data loaded", dataPoints)
//  		dataPoints.forEach(generateCircle);
// })


if (showLines) circles.forEach(item => connectTheDots(item._latlng));
//circles.forEach(item => console.log(item));
function generateCircle(datum){
  console.log(datum)
  var circle = L.circle(datum.location.split(","), {
    color: "white" || circleColors[datum.cat] || "blue",
    fillColor: circleColors[datum.cat]|| "blue",
    fillOpacity: 0.0,
    radius: Math.random()* 15 + 50,
  }).addTo(map);
  circles.push(circle);
}

//If we dont want dots to connect to themselves, one elegant solution would be
// To randomly shuffle the array of dots and then normally call this function with previous mode
function connectTheDots(arr){
  if (connection == "previous"){
    if(current){
      var polyline = L.polyline([current, arr], {color: lineColor}).addTo(map);
      lines.push(polyline);
    }
    current = arr;
  }
  else if (connection == "random"){
    console.log("generating random connection lines");
    var ranCircle = circles[Math.floor(Math.random() * circles.length)];
    console.log("rancircle:", ranCircle);
    var polyline = L.polyline([arr, ranCircle._latlng], {color: lineColor, opacity:.7}).addTo(map);
    lines.push(polyline);
  }
}

console.log(circles[Math.floor(Math.random() * circles.length)]);

var depth = 0; 
for(depth; depth < maxGrowth; depth++){
  childCircles.push([]);
  if (depth == 0) { circles.forEach(spawnChild) }
  else { 
    //console.log(childCircles)
    childCircles[depth -1].forEach(spawnChild) ;
  }
}

circles.forEach(circle => circle.bringToFront());
//Different algorithm, each circle spawns an additional circle next to it with variable repitition.

function spawnChild(obj){
  //console.log("birthing another", depth);
  var cLat = obj._latlng.lat + ((Math.random() > 0.5 ? 0.001 : -0.009) + Math.random() * 0.008)/ spread;
  var cLng = obj._latlng.lng + ((Math.random() > 0.5 ? 0.001 : -0.009) + Math.random() * 0.008)/ spread;
  //console.log(cLat, cLng);
  //console.log("color", (depth == 0 ? "f4c842": (parseInt(obj.options.fillColor,16) - 10)));
  var circle = L.circle([cLat,cLng], {
    //color: obj.options.color || "blue",
    opacity: 0,
    fillColor: kombuchaColors[Math.floor(Math.random()* kombuchaColors.length)] || obj.options.fillColor,
    fillOpacity: 1,
    radius: Math.random()* 30 + 10,
  }).addTo(map);
  childCircles[depth].push(circle);
}

/*
//Trying to get the pixel values for each pixel on the map so I can detect its color.
//Running into the prible that its not allowed to draw a canvas from cross origin data :S
//Implemented this workaround but I think it gives an invalid src to the image so I get back 0,0,0,0 as data
//hmm actually https://korona.geog.uni-heidelberg.de/tiles/roadsg/x=4207&y=2692&z=13?1497279224020 seems to work fine, so it might be something else
//css selector: leaflet-tile-loaded
var tileContainer = document.getElementsByClassName("leaflet-tile-container");
var tileImgs = Array.from(tileContainer[0].children);
console.log(tileImgs[0]);

//tileImgs.forEach(img => img.src = "");

var img = tileImgs[0];
//img.crossOrigin = "Anonymous";
console.log(img);
img.src = img.src + '?' + new Date().getTime();
img.setAttribute('crossOrigin', '');
var canvas = document.createElement('canvas');
canvas.width = img.width;
canvas.height = img.height;
canvas.getContext('2d').drawImage(img, 0, 0, img.width, img.height);

var pixelData = canvas.getContext('2d').getImageData(0, 0, 100, 100).data;

var pixelSize = 0;
pixelData.forEach(el => pixelSize+= el);
console.log(pixelData);
console.log(pixelSize);
*/

